#!/usr/bin/perl -w
use CGI::Carp qw(fatalsToBrowser);
#######################################################################################
# Frank	Herrmann
# herrmann@inx.de
# http://xpix.dieserver.de
my $version="0.1";

use strict;
use CGI;
use DBI;

my $q = CGI::new();

# ------------- User Vars TOP
# MySQL Settings NEU
my $host	= 'xpix.dieserver.de';
my $kenn	= 'xxxx';
my $pw	 	= 'xxxx';
my $base 	= 'pts';

my $HEADER = 0;

# ------------- User Vars End
my $ACTION  	= $q->param('action');
my $CHANNEL  	= $q->param('channel');
my $MARKS	= $q->param('marks');
my $NOAD	= $q->param('noad');
my $FROM  	= $q->param('from');
my $TO		= $q->param('to');
my $TXTFORMAT	= $q->param('txt');
my $ALL		= $q->param('all');
my $DEBUG	= $q->param('debug');

html(' ');

# Zur Datenbank connecten
my $DBH = &db_connect;
if($ACTION eq 'add_user') {
	&add_user($q->param('user'), $q->param('password'), $q->param('offset'))	
} 

if($ACTION eq 'list_user') {
	if($q->param('user')) {
		html(hash_to_txt($DBH->selectall_hashref(sprintf('select userid, offset, changed_at from user where userid = "%s"', $q->param('user')) , 'userid')))
	} else {
		html(hash_to_txt($DBH->selectall_hashref('select userid, offset, changed_at from user', 'userid')))
	}
} 

if($ACTION eq 'change_user') {
	&change_user($q->param('user'), $q->param('password'), $q->param('offset'))	
} 

if($MARKS) {
	&add_to_database($CHANNEL, $MARKS, $q->param('user'), $q->param('password'));
} else {
	&read_from_database($CHANNEL, $FROM, $TO);
}
exit;

# SUBROUTINEN -----------------------------------------------------------
# -----------------------------------------------------------------------

# ------------------ 
sub add_user {
# ------------------ 
	my $user = shift || return html ('No Username!' );
	my $password = shift || return html ('No Password!' );
	my $offset = shift;

	my $sql = sprintf("Select count(userid) as zahl from user where userid = '%s'", $user);		
	my $erg = $DBH->selectall_arrayref($sql) || html($DBI::errstr);

	if($erg->[0][0]) {
		return html("<pre>#Sorry, but this User (%s) exists in this Database!\n", $user);
	}	

	$sql = sprintf("INSERT INTO user (userid, offset, password) values ( '%s', '%d', PASSWORD('%s'))",
			$user, $offset, $password);		

	$erg = &db_exe_sql($sql);

	html("<pre>#Hallo %s, welcome in PTS-Marks-System ;-)!\n", $user)
		if($erg);
}

# ------------------ 
sub check_user {
# ------------------ 
	my $user = shift || html("<pre>#Error: No User!\n");
	my $password = shift || html("<pre>#Error: No Password!\n");;
	my $sql = sprintf("Select userid from user where userid = '%s' and PASSWORD('%s') = password", $user, $password);		
	my $erg = $DBH->selectall_arrayref($sql) || html($DBI::errstr);

	unless($erg->[0][0]) {
		html("<pre>#Sorry, not correct password or user!\n");
		return 0;
	}	
	return 1;
}



# ------------------ 
sub change_user {
# ------------------ 
	my $user = shift || return html ('No Username!' );
	my $password = shift || return html ('No Password!' );
	my $offset = shift;

	&check_user($user, $password);

	my $sql = sprintf("UPDATE user SET offset = '%d' where userid = '%s'", $offset, $user);		
	my $erg = &db_exe_sql($sql);

	html("<pre>#Hello %s, your data is changed ;-)!\n", $user);
}

# -----------------------------
sub html {
# -----------------------------
	print $q->header unless $HEADER;
	$HEADER = 1;
	printf @_;
}

# -----------------------------
sub hash_to_table {
# -----------------------------
	my $hash = shift || html('Error: no hash!');
	my $t = '<table border=1>'; 
	my $second = 0;
	foreach my $id (sort keys %$hash) {
		unless($second) {
			foreach my $name (reverse sort keys %{$hash->{$id}}) {
				$t .= sprintf('<th>%s</th>', ucfirst $name);
			}			
			$second++;
		}
		$t .= '<tr>';
		foreach my $name (reverse sort keys %{$hash->{$id}}) {
			$t .= sprintf('<td>%s</td>', $hash->{$id}->{$name});
		}
		$t .= '</tr>';
	}
	$t;
}

# -----------------------------
sub hash_to_txt {
# -----------------------------
	my $hash = shift || html('Error: no hash!');
	my $second = 0;
	my $t = "#<pre>";
	foreach my $id (sort keys %$hash) {
		foreach my $name (reverse sort keys %{$hash->{$id}}) {
			if($name eq 'marks') {
				$t .= "\nmarks: ---- \n";
				$t .= join("\n", split(/\-/, $hash->{$id}->{$name}));
				$t .= "\nmarks: ---- \n\n";
			} else {
				$t .= sprintf("%s\t\t%s\n", $name, $hash->{$id}->{$name});
			}
		}
		$t .= "----\n";
	}
	$t;
}

# -----------------------------
sub read_from_database {
# -----------------------------
	my $channel = shift;
	my $from = shift || 1;
	my $to = shift || time;
	my $sql;
	# Daten anzeigen
	if($ALL) {
		$sql = sprintf("Select * from pts2");		
	} else {
		$sql = sprintf("Select * from pts2 where zeit between FROM_UNIXTIME(%d) AND FROM_UNIXTIME(%d) AND channel = '%s'",
				$from, $to, $channel);		
	}
	my $erg = &db_exe_sql($sql);

	if($erg && $TXTFORMAT) {
		html(hash_to_txt($erg));
	} elsif($erg) {
		html(hash_to_table($erg));
	} else {
		html('<pre>#Sorry, i can\'t find PTS in this tiemframe!');
	}
}

# -----------------------------
sub add_to_database {
# -----------------------------
	my $channel = shift || return html('ERROR: Sorry, no channel!');
	my $marks = shift || return html('ERROR: Sorry, no Marks!');
	my $user = shift || 'unknown';
	my $password = shift;

	if($user ne 'unknown') {
		return unless &check_user($user, $password);
	}

	foreach my $mark (split(/\-/, $marks)) {
		my ($pts, $zeit) = split(/_/, $mark);		
		# Schauen ob die Daten schon existieren
		my $sql = sprintf("Select count(id) as zahl from pts2 where pts = '%s' and channel = '%s'", $pts, $channel);		
		my $erg = $DBH->selectall_arrayref($sql) || html($DBI::errstr);
		if($erg->[0][0]) {
			html("<pre>#Sorry, this pts(%s) in Channel (%s) exists in this Database!\n", $pts, $channel);
			next;
		}	

		# Daten abspeichern
		$sql = sprintf("INSERT INTO pts2 (pts, zeit, channel, noad, userid) values ( '%s', FROM_UNIXTIME(%d), '%s', %d, '%s')",
				$pts, $zeit, $channel, ($NOAD ? 1 : 0), $user );		
		$erg = &db_exe_sql($sql);

		html("<pre>#Danke, the PTS(%s) for Channel(%s) is saved!\n", $pts, $channel)
			if($erg);
	}
}


# -----------------------------
sub db_connect {
# -----------------------------
	my $dsn = "DBI:mysql:database=$base;host=$host;port=3306";
	my $dbh = DBI->connect($dsn,$kenn,$pw)
	  or return html("connecting : $DBI::errstr\n ");
	return $dbh;
}

# -----------------------------
sub db_exe_sql {
# -----------------------------
	my $sql_statement = shift || html('ERROR: No Statement'); 
	my $erg;
	if($sql_statement =~ /^select/si) {
		$erg = $DBH->selectall_hashref($sql_statement, 'id')
			or return html($DBI::errstr);
	} else {
		$erg = $DBH->do($sql_statement) || html('ERROR: %s', $DBH->errstr);
	}
	return $erg;
}
